# Copyright (c) 2002 ETH Zrich, Benno Luthiger. All rights reserved.
# See also LICENSE.txt

class Configurable:
    """Implementation of an object which is configurable both
    manually and programmatically and can be called like a script returning
    the configured value.
    """
    
    #__extends__ = ('OFS.SimpleItem.SimpleItem')

    def value(self):
        """Returns the value stored by this Configurable Object."""
    
    def name(self):
        """Returns the name of the property managed by this Configurable Object."""
 
    def set(self, value):
        """Sets the value to be stored by this Configurable Object."""
    
    def rename(self, name):
        """Renames the property managed by this Configurable Object."""
    
    def set_comment(self, comment):
        """Sets the comment explaining the property managed by this Configurable Object."""

    def comment(self):
        """Returns the comment explaining the property managed by this Configurable Object."""

    def type(self):
        """Returns the field type to edit the property managed by this Configurable Object."""
    
    def manage_edit(self, REQUEST):
        """Manage method to update the value stored by this Configurable Object."""
    
    def manage_type(self, REQUEST):
        """Manage method to update the configuration (e.g. type to edit the property)
           of this Configurable Object."""
    
    def manage_name(self, REQUEST):
        """Manage method to update name and comment explaining the property
           managed by this Configurable Object."""

    def manage_test(self):
        """Displays the test screen, i.e. calls the Configurable's value."""

    def get_editable_meta(self):
        """Returns the editable metadata (e.g. field size or item list)
           which configures this Configurable Object."""
    
    def set_as_list(self, items):
        """Method to configure programmatically this Object as ListField."""

    def set_as_radio(self, items):
        """Method to configure programmatically this Object as RadioField."""

    def set_as_checkbox(self):
        """Method to configure programmatically this Object as CheckBoxField."""

    def set_as_stringfield(self, field_size):
        """Method to configure programmatically this Object as StringField."""

    def set_as_integerfield(self, field_size):
        """Method to configure programmatically this Object as IntegerField."""

    def set_as_textarea(self, columns, rows):
        """Method to configure programmatically this Object as TextArea."""